<template>
  <div class="chart" :id="id"></div>
</template>

<script>
export default {
  name: "lineChart",
  props: {
    id: String,
    params: Array,
    xAxis: Array,
  },
  watch: {
    params: {
      handler: function (val) {
        if (val.length) {
          this.initData();
        }
      },
      deep: true,
    },
  },
  data() {
    return {
      chart: null,
    };
  },
  created() {},
  mounted() {
    this.initData();
  },
  methods: {
    setOption() {
      const that = this;
      const options = {
        color: this.colors || ["#4472c4", "#ed7d32", "#a5a5a5"],
        backgroundColor: "#fff",
        tooltip: {
          trigger: "item",
          confine: true,
        },
        legend: {
          show: true,
          bottom: 0,
          itemHeight: 2,
        },
        xAxis: {
          type: "category",
          data: this.xAxis,
          axisLine: { show: true, lineStyle: { color: "#e2e2e2" } },
          axisTick: {
            show: false,
          },
          axisLabel: {
            color: "#666",
          },
        },
        yAxis: {
          type: "value",
          axisLine: { show: false },
          splitLine: {
            show: true,
          },
          axisLabel: {
            color: "#666",
          },
        },
        grid: {
          top:28,
          left: "10%",
          right: "10%",
          bottom: 30,
          containLabel: true,
        },
        series: that.params.map((item) => {
          return {
            name: item.name,
            type: "line",
            symbol: "circle",
            symbolSize: "8",
            lineStyle: {
              width: 3,
            },
            data: item.value,
          };
        }),
      };
      return options;
    },
    initData() {
      if (!this.chart) {
        const div = document.getElementById(this.id);
        this.chart = this.$echarts.init(div);
      }
      const options = this.setOption();
      this.chart?.clear();
      this.chart.setOption(options, true);
      this.chart.off("click");
      this.chart.on("click", "series", (params) => {
        // this.$emit("clickPieChart", params);
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.chart {
  height: 100%;
}
</style>
